program Project1;

uses //windows,
  sysutils,
  hexfilewrite,
  classes,
  usbprocs in 'usbprocs.pas',
  picprocs;



{$ifdef win32}
  {$R *.RES}
{$endif}
var
  exitflag : boolean;


procedure testcomms;
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

begin
  send_buf[0] := TEST_COMS;      // Command
    //send_buf[1] := value;

    RecvLength:=8; // expected receive length

    if(SendReceivePacket(@send_buf[0],2,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       receive_buf[8] := 0;
       writeln('success-'+pchar(@receive_buf[0]));
    end else
       writeln('USB Operation Failed\r\n');
end;

procedure readlocation;
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

var
  location : longint;
begin
  writeln('enter location');
  readln(location);

  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 7;// 7 commands for pic

  send_buf[2] := $00;
  send_buf[4] := $0E;
  send_buf[3] := location div 65536;
  send_buf[5] := $00;
  send_buf[7] := $6E;
  send_buf[6] := $F8;

  send_buf[8] := $00;
  send_buf[10] := $0E;
  send_buf[9] := location div 256;
  send_buf[11] := $00;
  send_buf[13] := $6E;
  send_buf[12] := $F7;

  send_buf[14] := $00;
  send_buf[16] := $0E;
  send_buf[15] := location;
  send_buf[17] := $00;
  send_buf[19] := $6E;
  send_buf[18] := $F6;

  //perform actual read
  send_buf[20] := $19;


    RecvLength:=2; // expected receive length

    if(SendReceivePacket(@send_buf[0],21,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       //receive_buf[8] := 0;
       writeln('success-'+inttohex(receive_buf[1],2));
    end else
       writeln('USB Operation Failed\r\n');
       writeln(recvlength);
end;


procedure readlocation2;
var
  location : longint;
  var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

begin
  writeln('enter location');
  readln(location);

  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 2;// 2 commands for programmer

  send_buf[2] := $30;
  send_buf[3] := location div 65536;
  send_buf[4] := location div 256;
  send_buf[5] := location;

  //perform actual read
  send_buf[6] := $19;


    RecvLength:=2; // expected receive length

    if(SendReceivePacket(@send_buf[0],7,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       //receive_buf[8] := 0;
       writeln('success-'+inttohex(receive_buf[1],2));
    end else
       writeln('USB Operation Failed\r\n');
       writeln(recvlength);
end;





function readanotherblock(count: byte) : string;
//should be faster since there is no setup sequence
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;
    i : integer;
begin
  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := count;//  commands for pic

  for i := 0 to count -1 do begin
    send_buf[2+(i{*2})] := $19;
    //send_buf[3+(i*2)] := $00;
  end;
  RecvLength:= count+1;
  if(SendReceivePacket(@send_buf[0],(count{*2})+2,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       //receive_buf[8] := 0;
       setlength(result,count);
       for i := 1 to count do begin
         result[i] := char(receive_buf[i]);
       end;

    end else begin
       result := '';
       writeln('USB Operation Failed\r\n');
       writeln(recvlength);
    end;
end;


procedure writetest1;
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

begin
  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 13;//  commands for programmer

  //(1)bsf eecon1,eepgd
  send_buf[2] := $00;
  send_buf[4] := $8E;
  send_buf[3] := $A6;

  //(2)bsf eecon1,cfgs
  send_buf[5] := $00;
  send_buf[7] := $8C;
  send_buf[6] := $A6;

  //(3)bsf eecon1,wren
  send_buf[8] := $00;
  send_buf[10] := $86;
  send_buf[9] := $A6;

  //(4)set table pointer to $3C0006
  send_buf[11] := $30;
  send_buf[12] := $3C ;
  send_buf[13] := $00;
  send_buf[14] := $06;

  //(5)write a value of 00 for a single panel write
  send_buf[15] := $0C;
  send_buf[17] := $00;
  send_buf[16] := $00;

  //direct access to code memory

  //(6)bsf eecon1,eepgd
  send_buf[18] := $00;
  send_buf[20] := $8E;
  send_buf[19] := $A6;

  //(7)bcf eecon1,cfgs
  send_buf[21] := $00;
  send_buf[23] := $9C;
  send_buf[22] := $A6;

  //(8)set table pointer to $000000
  send_buf[24] := $30;
  send_buf[25] := $00 ;
  send_buf[26] := $00;
  send_buf[27] := $00;

  //(9) write 2 bytes and post increment by 2
  send_buf[28] := $0D;
  send_buf[29] := $01;
  send_buf[30] := $01;

  //(10) write 2 bytes and post increment by 2
  send_buf[31] := $0D;
  send_buf[32] := $02;
  send_buf[33] := $03;

  //(11) write 2 bytes and post increment by 2
  send_buf[34] := $0D;
  send_buf[35] := $05;
  send_buf[36] := $08;

  //(12) write 2 bytes and start programming
  send_buf[37] := $0F;
  send_buf[38] := $0D;
  send_buf[39] := $15;

  //(13)nop stretched during high of last command bit
  send_buf[40] := $40;


  RecvLength:=1; // expected receive length

    if(SendReceivePacket(@send_buf[0],41,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       writeln('success');
    end else
       writeln('USB Operation Failed\r\n');
  //sleep(1);
end;

procedure writetest2;
var
  a,b,tempbyte : byte;
  j : integer;
  var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

begin
  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 9;//  commands for programmer

  //(1)bsf eecon1,eepgd
  send_buf[2] := $00;
  send_buf[4] := $8E;
  send_buf[3] := $A6;

  //(2)bsf eecon1,cfgs
  send_buf[5] := $00;
  send_buf[7] := $8C;
  send_buf[6] := $A6;

  //(3)bsf eecon1,wren
  send_buf[8] := $00;
  send_buf[10] := $86;
  send_buf[9] := $A6;

  //(4)set table pointer to $3C0006
  send_buf[11] := $30;
  send_buf[12] := $3C ;
  send_buf[13] := $00;
  send_buf[14] := $06;

  //(5)write a value of 40 for a multi panel write
  send_buf[15] := $0C;
  send_buf[17] := $00;
  send_buf[16] := $40;

  //direct access to code memory

  //(6)bsf eecon1,eepgd
  send_buf[18] := $00;
  send_buf[20] := $8E;
  send_buf[19] := $A6;

  //(7)bcf eecon1,cfgs
  send_buf[21] := $00;
  send_buf[23] := $9C;
  send_buf[22] := $A6;

  //(8)major part of write sequence coordianated by pic to save buffer space
  send_buf[24] := $58;  //10 00

  send_buf[25] := $00;
  send_buf[26] := $00;
  send_buf[27] := $00;

  a := 1;
  b := 1;
  for j := 28 to 59 do begin
      send_buf[j] := a;
      tempbyte := a + b;
      a := b;
      b := tempbyte;
  end;

  //(9)nop stretched during high of last command bit
  send_buf[60] := $40;


  RecvLength:=1; // expected receive length

    if(SendReceivePacket(@send_buf[0],61,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       writeln('success');
    end else
       writeln('USB Operation Failed\r\n');
  //sleep(1);
end;

procedure read16;
var
  location : longint;
  count : integer;
  s: string;
  i : integer;
begin
  writeln('enter location');
  readln(location);
  writeln('enter count');
  readln(count);
  s := readblock(location,count);
  if length(s) > 0 then begin
    write('success-');
    for i := 1 to count do begin
      write(inttohex(ord(s[i]),2)+' ');
    end;
    writeln;
  end else begin
    writeln('USB Operation Failed\r\n');
    //writeln(recvlength);
  end;

end;

procedure dumphexfile;
var

  tempbyte : byte;
  buf : string;
  i ,j : integer;
  hexfile : thexfile;
  filename : string;
begin

  writeln('enter filename');
  readln(filename);
  hexfile_init(hexfile,tfilestream.Create(filename,fmCreate));
  for i := 0 to 1023 do begin
    if i = 0 then begin
      buf := readblock(i*32,32);
    end else begin
      buf := readanotherblock(32);
    end;
    if length(buf) = 0 then begin
      writeln('error-reading aborted');
      exit;
    end;
    hexfile_outputbytes(hexfile,i*32,copy(buf,1,16));
    hexfile_outputbytes(hexfile,(i*32)+16,copy(buf,17,16));
    if (i and $F) = $F then write('*');
  end;
  writeln;
  hexfile_done(hexfile);
  hexfile.target.free;
end;
var
  choice : integer;

begin
  initusb;
  repeat
    writeln('0: exit');
    writeln('1: bring up Vpp');
    writeln('2: take down Vpp');
    writeln('3: test comms');
    writeln('4: read location');
    writeln('5: read block');
    writeln('6: dump hex file');
    writeln('7: bulk erase');
    writeln('8: write test 1');
    writeln('9: read location v2');
    writeln('10: write test 2');
    readln(choice);

    case choice of
      0 : exitflag := true;
      1 : setvpp(0);
      2 : setvpp(1);
      3 : testcomms;
      4 : readlocation;
      5 : read16;
      6 : dumphexfile;
      7 : bulkerase;
      8 : writetest1;
      9 : readlocation2;
      10 : writetest2;
    end;
  until exitflag;

  shutdownusb;
end.
