unit hexfileread;

interface

procedure readhexfile(hexfile:string);
implementation
uses sysutils,globaldata;
var
  currenthigh : word;

function hexdec(s:string) : string;
var
  i ,j: integer;
  x : array [-1..0] of byte;
begin
  setlength(result,length(s) div 2);
  for i := 1 to length(result) do begin
    for j := -1 to 0 do begin
      case s[(i*2)+j] of
        'a'..'f' : x[j] := ord(s[(i*2)+j]) -ord('a')+10;
        'A'..'F' : x[j] := ord(s[(i*2)+j]) -ord('A')+10;
        '0'..'9' : x[j] := ord(s[(i*2)+j]) -ord('0');
      end;
    end;
    result[i] := char(x[-1]*16+x[0]);
  end;
end;

procedure readhexfile(hexfile:string);
var
  t:textfile;
  s,line : string;
  reclen: byte;
  loadoffs : word;
  rectyp,checksum : byte;
  i : integer;
  location : longint;
begin
  assignfile(t,hexfile);
  reset(t);
  repeat
    readln(t,line);
    if (length(line)=0) or (line[1] <> ':') then continue;
    s := hexdec(copy(line,2,1000));
    checksum := 0;
    for i := 0 to length(s) do begin
      checksum := checksum + ord(s[i]);
    end;
    if checksum <> 0 then begin
      raise exception.create('checksum failure');

    end;
    reclen := ord(s[1]);
    loadoffs := ord(s[2])*256+ord(s[3]);
    rectyp := ord(s[4]);
    if length(s) <> reclen+5 then raise exception.create('lengths don''t match');
    case rectyp of
      0 : begin
        location := currenthigh*65536+loadoffs;
        if location+reclen <= programmemorysize then begin
          move(s[5],programmemory[location],reclen);
        end;
        if location= $300000 then begin
          move(s[5],configbits[0],14);
        end;
      end;
      4 : begin
        currenthigh := ord(s[5])*256+ord(s[6]);
      end;
    end;
  until rectyp=1;
  closefile(t);
end;
end.
