unit hexfilewrite;

interface
uses
  classes;
type
  thexfile = record
    currenthigh : longint;
    target : tstream;
  end;

function hexenc(str : string) : string;
procedure hexfile_init(var hexfile : thexfile;target:tstream);
procedure hexfile_writeline(var hexfile : thexfile;loadoffset : word;rectyp:byte;data:string);
procedure hexfile_outputbytes(var hexfile : thexfile;location : longint;data:string);
procedure hexfile_done(var hexfile : thexfile);

implementation
const
  hexdigits : array[0..15] of char = ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');


function hexenc(str : string) : string;
var
  i : integer;
begin
  setlength(result,length(str)*2);
  for i := 1 to length(str) do begin
    result[(i*2)-1] := hexdigits[ord(str[i]) div 16];
    result[(i*2)  ] := hexdigits[ord(str[i]) mod 16];
  end;
end;

procedure hexfile_init(var hexfile : thexfile;target:tstream);
begin
  hexfile.target := target;
  hexfile.currenthigh := -1;

end;

procedure hexfile_writeline(var hexfile : thexfile;loadoffset : word;rectyp:byte;data:string);
var
  s : string;
  i : integer;
  checksum : byte;
begin
  s := char(length(data))+char(loadoffset div 256)+char(loadoffset mod 256)+char(rectyp)+data;
  checksum := 0;
  for i := 0 to length(s) do begin
    checksum := checksum - byte(s[i]);
  end;
  s := s + char(checksum);
  s := ':'+hexenc(s)+#13#10;
  hexfile.target.write(s[1],length(s));
end;
procedure hexfile_outputbytes(var hexfile : thexfile;location : longint;data:string);
begin
  if hexfile.currenthigh <> location div 65536 then begin
    hexfile.currenthigh := location div 65536;
    hexfile_writeline(hexfile,0000,4,char(hexfile.currenthigh mod 256)+char(hexfile.currenthigh div 256));
  end;
  hexfile_writeline(hexfile,location mod 65536,0,data);
end;

procedure hexfile_done(var hexfile : thexfile);
begin
  hexfile_writeline(hexfile,0000,1,'');
end;
end.
