unit picprocs;

interface
const
    READ_VERSION = $50;
    SET_VPP = $51;
    TEST_COMS = $52;
    PERFORM_COMMANDS = $53;
procedure setvpp(value : integer);
procedure initusb;
procedure shutdownusb;
procedure doprog(address:integer;panels:integer;bytestowriteperpanel:integer);
procedure bulkerase;
procedure writeconfigbits;
function readblock(location: longint;count: byte) : string;
implementation
uses
  sysutils,usbprocs,globaldata,math,
  {$ifdef win32}
    windows;
  {$else}
    usb;
  {$endif}


procedure doprogpacket(address:integer;panels:integer;bytestowriteperpanel:integer;startactualwrite:boolean);
var
  a,b,tempbyte : byte;
  j : integer;
  var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

begin
  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 9;//  commands for programmer

  //(1)bsf eecon1,eepgd
  send_buf[2] := $00;
  send_buf[4] := $8E;
  send_buf[3] := $A6;

  //(2)bsf eecon1,cfgs
  send_buf[5] := $00;
  send_buf[7] := $8C;
  send_buf[6] := $A6;

  //(3)bsf eecon1,wren
  send_buf[8] := $00;
  send_buf[10] := $86;
  send_buf[9] := $A6;

  //(4)set table pointer to $3C0006
  send_buf[11] := $30;
  send_buf[12] := $3C ;
  send_buf[13] := $00;
  send_buf[14] := $06;

  //(5)write a value of 40 for a multi panel write
  //null this out for new sytle pics, it doesn't actually seem to do any harm though
  if picspecs.newstyle then begin
    send_buf[15] := $00;
    send_buf[17] := $00;
    send_buf[16] := $00;
  end else begin
    send_buf[15] := $0C;
    send_buf[17] := $00;
    send_buf[16] := $40;
  end;
  //direct access to code memory

  //(6)bsf eecon1,eepgd
  send_buf[18] := $00;
  send_buf[20] := $8E;
  send_buf[19] := $A6;

  //(7)bcf eecon1,cfgs
  send_buf[21] := $00;
  send_buf[23] := $9C;
  send_buf[22] := $A6;

  //(8)major part of write sequence coordianated by pic to save buffer space
  //FIXME: generalise this
  //send_buf[24] := $58;  //10 00
  send_buf[24] := $50 + (round(log2(panels)) * 4)+ round(log2(bytestowriteperpanel/8));
  if not startactualwrite then send_buf[24] := send_buf[24] +$20; //make most significant digit 7
  //writeln(inttohex(send_buf[24],2));
  send_buf[25] := address div 65536;
  send_buf[26] := address div 256;
  send_buf[27] := address;

  a := 1;
  b := 1;
  {for j := 28 to 59 do begin
      send_buf[j] := a;
      tempbyte := a + b;
      a := b;
      b := tempbyte;
  end;}
  for j := 0 to panels-1 do begin
    move(programmemory[address+(picspecs.panelsize*j)],send_buf[28+bytestowriteperpanel*j],bytestowriteperpanel);
  end;


  //(9)nop stretched during high of last command bit
  send_buf[28+(bytestowriteperpanel*panels)] := $40;


  RecvLength:=1; // expected receive length

    if(SendReceivePacket(@send_buf[0],28+(bytestowriteperpanel*panels)+1,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
      // writeln('success');
    end else
       writeln('USB Operation Failed\r\n');
  //sleep(1);
end;

procedure doprog(address:integer;panels:integer;bytestowriteperpanel:integer);
var
  i : integer;
  packets : integer;
begin
  if bytestowriteperpanel <= 32 then begin
    doprogpacket(address,panels,bytestowriteperpanel,true);
  end else begin
    packets := bytestowriteperpanel div 32;
    for i := 0 to packets-1 do begin
      doprogpacket(address+(i*32),1,32,i=packets-1);
    end;
  end;
end;

procedure setvpp(value : integer);
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

begin
  send_buf[0] := SET_VPP;      // Command
    send_buf[1] := value;

    RecvLength:=1; // expected receive length

    if(SendReceivePacket(@send_buf[0],2,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       writeln('success');
    end else
       raise exception.create('USB Operation Failed\r\n');
end;
{$ifdef win32}
  procedure initusb;
  var
    max_count ,i : longint;
    temppipe : thandle;
    count : integer;
    mostrecentlyfound: integer;
  
 
  
    selection : DWORD;
 
  
  begin
    //search for devices
    count := 0;
    max_count := MPUSBGetDeviceCount(vid_pid);
    writeln(max_count,' devices');
    for  i := 0 to MAX_NUM_MPUSB_DEV -1 do begin
 
      tempPipe := MPUSBOpen(i,vid_pid,Nil,MP_READ,0);
      if(tempPipe <> INVALID_HANDLE_VALUE) then begin
        writeln('Instance Index # ',i);
        mostrecentlyfound := i;
        MPUSBClose(tempPipe);
        count := count+1;
      end;
      if(count = max_count) then break;
    end;

    //choose device
    case count of
      0: begin
        writeln('no devices found');
        halt;
      end;
      1: begin
        writeln('found only one device using it');
        selection := mostrecentlyfound;
      end;
      else begin
        writeln('found multiple devices');
              // First we need to open data pipes...
        //fflush(stdin);
        writeln('Enter a valid instance index to open a USB connection: ');
        //scanf("%d",&selection);
        readln(selection);
      end;
    end;

    //connect to it,
    myOutPipe := MPUSBOpen(selection,vid_pid,out_pipe,MP_WRITE,0);
    myInPipe := MPUSBOpen(selection,vid_pid,out_pipe,MP_READ,0);
    writeln(myoutpipe,' ',myinpipe,' ',INVALID_HANDLE_VALUE);
    if(myOutPipe = INVALID_HANDLE_VALUE) or (myInPipe = INVALID_HANDLE_VALUE) then begin
 
      writeln('Failed to open data pipes.\r\n');
      //return;
      exit;
    end;//}//end if


  end;
  
  procedure shutdownusb;
  begin
    //shut down.
    MPUSBClose(myOutPipe);
  
      MPUSBClose(myInPipe);
      myOutPipe := INVALID_HANDLE_VALUE;
      myInPipe := INVALID_HANDLE_VALUE;
  end;

{$else}
                                   

  procedure initusb;
  var                                                                             
    busses : Pusb_bus;                                                            
    bus : Pusb_bus;                                                               
    dev : Pusb_device; 
    found : boolean;
    founddev : pusb_device;
  begin                                                                           
    usb_init;                                                                     
    usb_find_busses;                                                              
    usb_find_devices;                                                             
	                                                                                      
    busses := usb_get_busses;                                                     
    found := false;		                                                                                
    bus := busses;                                                                
    while assigned(bus) do begin                                                  
      dev := bus.devices;                                                         
      while assigned(dev) do begin                                                
        //writeln('vendor:',inttohex(dev.descriptor.idvendor,4),' product:',inttohex
        if (dev.descriptor.idvendor = $04D8) and (dev.descriptor.idproduct = $000C) then begin
	  found := true; 
	  founddev := dev;
	end;
	dev := dev.next;                                                          
      end;                                                                        
      bus := bus.next;                                                            
    end;  
    
    if found then begin
      dev_handle := usb_open(founddev);
    end else begin
      writeln('device not found');
      halt;
    end;
                                                                            
  end;       
  
  procedure shutdownusb();
  begin
    usb_close(dev_handle);
  end;
{$endif}

procedure bulkerase;
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;
    bytestosend : integer;
begin

  if picspecs.newstyle then begin
    send_buf[0] := PERFORM_COMMANDS;      // Command

    send_buf[1] := 16;//  commands for pic

    send_buf[2] := $00;
    send_buf[4] := $0E;
    send_buf[3] := $3C;
    send_buf[5] := $00;
    send_buf[7] := $6E;
    send_buf[6] := $F8;

    send_buf[8] := $00;
    send_buf[10] := $0E;
    send_buf[9] := $00;
    send_buf[11] := $00;
    send_buf[13] := $6E;
    send_buf[12] := $F7;

    send_buf[14] := $00;
    send_buf[16] := $0E;
    send_buf[15] := $05;
    send_buf[17] := $00;
    send_buf[19] := $6E;
    send_buf[18] := $F6;

    send_buf[20] := $0C;
    send_buf[22] := $0f;
    send_buf[21] := $0f;


    send_buf[23] := $00;
    send_buf[25] := $0E;
    send_buf[24] := $3C;
    send_buf[26] := $00;
    send_buf[28] := $6E;
    send_buf[27] := $F8;

    send_buf[29] := $00;
    send_buf[31] := $0E;
    send_buf[30] := $00;
    send_buf[32] := $00;
    send_buf[34] := $6E;
    send_buf[33] := $F7;

    send_buf[35] := $00;
    send_buf[37] := $0E;
    send_buf[36] := $04;
    send_buf[38] := $00;
    send_buf[40] := $6E;
    send_buf[39] := $F6;

    send_buf[41] := $0C;
    send_buf[43] := $87;
    send_buf[42] := $87;

    send_buf[44] := $00;
    send_buf[46] := $00;
    send_buf[45] := $00;

    send_buf[47] := $20;
    send_buf[49] := $00;
    send_buf[48] := $00;
    bytestosend := 50;
  end else begin
    send_buf[0] := PERFORM_COMMANDS;      // Command

    send_buf[1] := 9;//  commands for pic

    send_buf[2] := $00;
    send_buf[4] := $0E;
    send_buf[3] := $3C;
    send_buf[5] := $00;
    send_buf[7] := $6E;
    send_buf[6] := $F8;

    send_buf[8] := $00;
    send_buf[10] := $0E;
    send_buf[9] := $00;
    send_buf[11] := $00;
    send_buf[13] := $6E;
    send_buf[12] := $F7;

    send_buf[14] := $00;
    send_buf[16] := $0E;
    send_buf[15] := $04;
    send_buf[17] := $00;
    send_buf[19] := $6E;
    send_buf[18] := $F6;

    send_buf[20] := $0C;
    send_buf[22] := $00;
    send_buf[21] := $80;

    send_buf[23] := $00;
    send_buf[25] := $00;
    send_buf[24] := $00;

    send_buf[26] := $20;
    send_buf[28] := $00;
    send_buf[27] := $00;
    bytestosend := 29;
  end;
  RecvLength:=1; // expected receive length

    if(SendReceivePacket(@send_buf[0],bytestosend,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       writeln('success');
    end else
       writeln('USB Operation Failed\r\n');
  //sleep(1);
end;

procedure writeconfigbits;
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;
    i : integer;
begin
  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 5;//  commands for programmer

  //(1)bsf eecon1,eepgd
  send_buf[2] := $00;
  send_buf[4] := $8E;
  send_buf[3] := $A6;

  //(2)bsf eecon1,cfgs
  send_buf[5] := $00;
  send_buf[7] := $8C;
  send_buf[6] := $A6;

  //(3)bsf eecon1,wren
  send_buf[8] := $00;
  send_buf[10] := $86;
  send_buf[9] := $A6;

  //(4)set table pointer to $300000
  send_buf[11] := $30;
  send_buf[12] := $30 ;
  send_buf[13] := $00;
  send_buf[14] := $00;

  //(5)perform main block of config bits writing.
  send_buf[15] := $60;

  move(configbits[0],send_buf[16],14);


  RecvLength:=1; // expected receive length

    if(SendReceivePacket(@send_buf[0],30,@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       writeln('success');
    end else
       writeln('USB Operation Failed\r\n');
  //sleep(1);

end;
function readblock(location: longint;count: byte) : string;
var
    send_buf,receive_buf : array[0..63] of byte;
    RecvLength : dword;

var
  i : integer;
begin
  send_buf[0] := PERFORM_COMMANDS;      // Command

  send_buf[1] := 6+count;//  commands for pic

  send_buf[2] := $00;
  send_buf[4] := $0E;
  send_buf[3] := location div 65536;
  send_buf[5] := $00;
  send_buf[7] := $6E;
  send_buf[6] := $F8;

  send_buf[8] := $00;
  send_buf[10] := $0E;
  send_buf[9] := location div 256;
  send_buf[11] := $00;
  send_buf[13] := $6E;
  send_buf[12] := $F7;

  send_buf[14] := $00;
  send_buf[16] := $0E;
  send_buf[15] := location;
  send_buf[17] := $00;
  send_buf[19] := $6E;
  send_buf[18] := $F6;
  for i := 0 to count -1 do begin
    send_buf[20+(i{*2})] := $19;
    //send_buf[21+(i*2)] := $00;
  end;
  RecvLength:= count+1;
  if(SendReceivePacket(@send_buf[0],20+(count{*2}),@receive_buf[0],@RecvLength,1000,1000) = 1) then begin
       //receive_buf[8] := 0;
       setlength(result,count);
       for i := 1 to count do begin
         result[i] := char(receive_buf[i]);
       end;

    end else begin
       result := '';
       writeln('USB Operation Failed\r\n');
       writeln(recvlength);
    end;
end;

end.
