unit usbprocs;

interface
uses
  {$ifdef win32}
    windows;
  {$else}
    usb;
  {$endif}

{$ifdef win32}
  const
    MAX_NUM_MPUSB_DEV = 127;
    MP_WRITE = 0;
    MP_READ = 1;
    vid_pid = 'vid_04d8&pid_000c';
    out_pipe= '\MCHP_EP1';
    in_pipe= '\MCHP_EP1';
  //DWORD MPUSBGetDLLVersion(void);
  
  function MPUSBGetDeviceCount(pVID_PID:pchar) :dword ;{ stdcall}cdecl; external 'mpusbapi.dll' name '_MPUSBGetDeviceCount';
  
  //(*extern "C" __declspec(dllexport)
  function MPUSBOpen(instance:DWORD;    // Input
                 pVID_PID:pchar;    // Input
                 pEP:pchar;         // Input
                 dwDir:DWORD;       // Input
                 dwReserved:DWORD):thandle;cdecl; external 'mpusbapi.dll' name '_MPUSBOpen'; // Input <Future Use>

  function MPUSBRead(handle:integer;              // Input
                pData:pointer;                // Output
                dwLen:dword;                // Input
                pLength:pdword;             // Output
                dwMilliseconds:dword):dword;cdecl; external 'mpusbapi.dll' name '_MPUSBRead';      // Input

  //extern "C" __declspec(dllexport)
  function MPUSBWrite(handle:thandle;             // Input
                 pData:pointer;               // Input
                 dwLen:dword;               // Input
                 pLength:pdword;            // Output
                 dwMilliseconds:dword):dword;cdecl; external 'mpusbapi.dll' name '_MPUSBWrite';     // Input
  (*
  extern "C" __declspec(dllexport)
  DWORD MPUSBReadInt(HANDLE handle,           // Input
                   PVOID pData,             // Output
                   DWORD dwLen,             // Input
                   PDWORD pLength,          // Output
                   DWORD dwMilliseconds);   // Input
  *)
  //extern "C" __declspec(dllexport)
  function MPUSBClose(handle:thandle) : longbool;cdecl; external 'mpusbapi.dll' name '_MPUSBClose'; // Input <Future Use>
  //*)
  
  //procedure TForm1.Button1Click(Sender: TObject);
  procedure CheckInvalidHandle;
{$endif}
function SendReceivePacket(SendData:pbyte; SendLength:dword; ReceiveData:pbyte;
                    ReceiveLength:pdword; SendDelay:cardinal; ReceiveDelay:cardinal) :dword;

var
  {$ifdef win32}
    myOutPipe,myinPipe : Thandle;
  {$else}
    dev_handle : pusb_dev_handle;
  {$endif}
implementation

{$ifdef win32}
  procedure CheckInvalidHandle;
  begin
    if(GetLastError() = ERROR_INVALID_HANDLE) then begin

  
        // Most likely cause of the error is the board was disconnected.
        MPUSBClose(myOutPipe);
        MPUSBClose(myInPipe);
        myOutPipe := INVALID_HANDLE_VALUE;
        myInPipe := INVALID_HANDLE_VALUE;
    //}//end if
    end else
        writeln('Error Code ',GetLastError());
  end;//}//end CheckInvalidHandle


  function SendReceivePacket(SendData:pbyte; SendLength:dword; ReceiveData:pbyte;
                      ReceiveLength:pdword; SendDelay:cardinal; ReceiveDelay:cardinal) :dword;
  var
    SentDataLength : dword;
    ExpectedReceiveLength :dword;
  begin
    ExpectedReceiveLength := ReceiveLength^;
    if(myOutPipe <> INVALID_HANDLE_VALUE)and(  myInPipe <> INVALID_HANDLE_VALUE) then begin
        if(MPUSBWrite(myOutPipe,SendData,SendLength,@SentDataLength,SendDelay)<>0) then begin


            if(MPUSBRead(myInPipe,ReceiveData, ExpectedReceiveLength,
                        ReceiveLength,ReceiveDelay)<>0) then begin

                if(ReceiveLength^ = ExpectedReceiveLength) then begin

                    //return 1;   // Success!
                    result := 1;
                    exit;
                end else if(ReceiveLength^ < ExpectedReceiveLength) then begin
                    //return 2;   // Partially failed, incorrect receive length
                    result := 2;
                    exit;
                end;//}//end if else

            end else
                CheckInvalidHandle();

        end else
            CheckInvalidHandle();

    end;
    //return 0;  // Operation Failed
    result := 0;
  end;//}//end SendReceivePacket
{$else}
  function SendReceivePacket(SendData:pbyte; SendLength:dword; ReceiveData:pbyte;
                      ReceiveLength:pdword; SendDelay:cardinal; ReceiveDelay:cardinal) :dword;
  var
    SentDataLength : dword;
    ExpectedReceiveLength :dword;
  begin
    ExpectedReceiveLength := ReceiveLength^;
    begin
        
        sentdatalength := USB_bulk_Write(dev_handle,1,pchar(SendData),SendLength,SendDelay);
	if sentdatalength > 0 then begin


            receivelength^ := usb_bulk_read(dev_handle,1,pchar(ReceiveData), ExpectedReceiveLength,ReceiveDelay);
	    if receivelength^ > 0 then begin

                if(ReceiveLength^ = ExpectedReceiveLength) then begin

                    //return 1;   // Success!
                    result := 1;
                    exit;
                end else if(ReceiveLength^ < ExpectedReceiveLength) then begin
                    //return 2;   // Partially failed, incorrect receive length
                    result := 2;
                    exit;
                end;//}//end if else

            end;
                

        end;
            

    end;
    //return 0;  // Operation Failed
    result := 0;
  end;//}//end SendReceivePacket

{$endif}
end.
